- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# iam_role_info – Gather information on IAM roles

New in version 2.5.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Gathers information about IAM roles
- This module was called `iam_role_facts` before Ansible 2.9. The usage did not change.

Aliases: iam_role_facts

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
name - |  | Name of a role to search for Mutually exclusive with `prefix` aliases: role_name
path_prefix - |  | Prefix of role path to restrict IAM role search for Mutually exclusive with `name`
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    # find all existing IAM roles
    - iam_role_info:
      register: result

    # describe a single role
    - iam_role_info:
        name: MyIAMRole

    # describe all roles matching a path prefix
    - iam_role_info:
        path_prefix: /application/path

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
iam_roles complex | always | List of IAM roles
| arn string | always | Amazon Resource Name for IAM role Sample: arn:aws:iam::123456789012:role/AnsibleTestRole
| assume_role_policy_document string | always | Policy Document describing what can assume the role
| create_date string | always | Date IAM role was created Sample: 2017-10-23T00:05:08+00:00
| inline_policies list | always | List of names of inline policies
| instance_profiles complex | always | List of attached instance profiles
|  | arn string | always | Amazon Resource Name for the instance profile Sample: arn:aws:iam::123456789012:instance-profile/AnsibleTestEC2Policy
|  | create_date string | always | Date instance profile was created Sample: 2017-10-23T00:05:08+00:00
|  | instance_profile_id string | always | Amazon Identifier for the instance profile Sample: AROAII7ABCD123456EFGH
|  | instance_profile_name string | always | Name of instance profile Sample: AnsibleTestEC2Policy
|  | path string | always | Path of instance profile Sample: /
|  | roles list | always | List of roles associated with this instance profile
| managed_policies complex | always | List of attached managed policies
|  | policy_arn string | always | Amazon Resource Name for the policy Sample: arn:aws:iam::123456789012:policy/AnsibleTestEC2Policy
|  | policy_name string | always | Name of managed policy Sample: AnsibleTestEC2Policy
| path string | always | Path of role Sample: /
| role_id string | always | Amazon Identifier for the role Sample: AROAII7ABCD123456EFGH
| role_name string | always | Name of the role Sample: AnsibleTestRole

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Will Thames (@willthames)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.